/* 
 *
 * 2004-2008  Met_Enkeph aka Evan Eveland
 *
 */
var deskcutMenuItems = new Array("deskcut-do-view", "deskcut-do-viewlink");
var gdeskcutBundle;
window.addEventListener("load", deskcutInit, false);

// -----------------------------------------------------------------------------
// -- deskcutInit()
// ---- called on window load by window.addEventListener statement
function deskcutInit() 
{
  var menu = document.getElementById("contentAreaContextMenu");
  menu.addEventListener("popupshowing",deskcutContext,false);
  gdeskcutBundle = document.getElementById("deskcut_strings");
  if (! gdeskcutBundle) 
  {
    alert("no bundle");
  }
}
// -----------------------------------------------------------------------------
// -- deskcutContext()
// ---- called on context menu popup by menu.addEventListener in deskcutInit
function deskcutContext() 
{
  if(gContextMenu) 
  {
    for(var i=0; i<deskcutMenuItems.length; i++) 
    {
      var menuitem = document.getElementById(deskcutMenuItems[i]);
      if(menuitem && (i == 0)) 
      {
        menuitem.hidden = (gContextMenu.isTextSelected || gContextMenu.onLink || gContextMenu.onImage || gContextMenu.onTextInput );
      } 
      else if (menuitem) 
      {
        menuitem.hidden = ! gContextMenu.onLink;
      }
    }
  }
  menuitem = null;
}

// -----------------------------------------------------------------------------
// -- doDeskCut(lsType)
function doDeskCut(lsType) 
{
  if (gContextMenu) 
  {
    var href;
    var name;
    if (lsType == 'link') 
    {
      // A little work-around from http://forums.mozillazine.org/viewtopic.php?t=316016
      try 
      {
        href = gContextMenu.linkURL();
      } 
      catch(e) 
      {
        href = gContextMenu.linkURL;
      } 
      name = getFileName(true);
    } 
    else 
    {
      href = gBrowser.currentURI.spec;
      name = getFileName(false);
    }
    var str = getDestDir();
    if (href == "" || str == "" || name == "") 
    {
      alert("href: "+href+"\n deskloc: "+str+"\n name: "+name );
      return;
    }
    else 
    {
      var creat_succ = createShortcut(href,str, name);
      postCreate(creat_succ,href);
    }
  }
}

// -----------------------------------------------------------------------------
// --  getDestDir()
// ---- called by doDeskCut()
// ---- return the destination dir by checking out prefs
// ---- if needed prompt for the dir (and save if "remember last" is set)
function getDestDir() 
{
  var pref = getDeskcutPrefs();
  var dirScheme = pref.get("dir_scheme");
  var retDir = detectWdirScheme(dirScheme);
  pref = null;
  return retDir;
}

// -----------------------------------------------------------------------------
// --  detectWdirScheme(scheme)
// ---- called by getDestDir
// ---- returns a string based on the dirScheme in use
// ---- 0 = prompt for path
// ---- 1 = prompt for path, but remember it
// ---- 2 = find desktop
// ---- 3 = use stored value
// ------ note: 2 and 3 will call pathPrompt() if they cant get a valid value
function detectWdirScheme(scheme) 
{
  var retVal = "";
  switch (scheme) 
  {
    case 0:
      retVal = pathPrompt("deskcut.detectWdirScheme");
      break;

    case 1:
      retVal = pathPrompt("deskcut.detectWdirScheme");
      deskcut_pref.setCharPref('deskcut.desk_path',retVal);
      deskcut_pref.setIntPref('deskcut.dir_scheme', '3');
      break;

    case 2:
      retVal = getDesktop();
      if (retVal == '') 
      {
        retVal = pathPrompt("deskcut.detectWdirScheme");
      }
      break;

    case 3:
      var pref = getDeskcutPrefs();
      retVal = pref.get("desk_path");
      if (retVal == '') 
      {
        retVal = pathPrompt("deskcut.detectWdirScheme");
      }
      break;

    default:
      // alert ("Bad Things in detectWdirScheme!")
      retVal = pathPrompt("deskcut.detectWdirScheme");
      break;
  }
  return retVal;
}

// -----------------------------------------------------------------------------
// -- getFileName(isLink)
// ---- called by doDeskCut()
// ---- return the file name by checking out prefs
// ---- if needed prompt for the name
// ---- isLink is a boolean telling us if were clicking on a link (true) or a page (false)
function getFileName(isLink) 
{
  var pref = getDeskcutPrefs();
  var nameScheme = pref.get("name_scheme");
  var addDate = pref.get("add_date");
  var retName = detectWnameScheme(nameScheme,addDate,isLink);
  return retName;
}

// -----------------------------------------------------------------------------
// --  detectWnameScheme(scheme,date,isLink)
// ---- called by getFileName()
// ---- return a string based on the nameScheme in use
// ---- 0 = prompt for name
// ---- 1 = use page name/title
// ---- 2 = use href
// ---- If addDate is True add the Date to the name
function detectWnameScheme(scheme,addDate,isLink) {
  var retVal = "";
  switch (scheme) 
  {
    case 0:
      retVal = doPrompt("deskcut.detectWnameScheme");
      break;

    case 1:
      if (isLink) 
      {
        retVal = gContextMenu.linkText();
      } 
      else 
      {
        retVal = gBrowser.contentDocument.title;
      }
      if (retVal == "") 
      {
        retVal = detectWnameScheme(2,addDate,isLink);
      }
      break;

    case 2:
      if (isLink) 
      {
        retVal = gContextMenu.linkURL();
      } 
      else 
      {
        retVal = gBrowser.currentURI.spec;
      }
      break;

    default:
      if (isLink) 
      {
        retVal = gContextMenu.linkText();
      } 
      else 
      {
        retVal = gBrowser.contentDocument.title;
      }
      if (retVal == "") 
      {
        retVal = detectWnameScheme(2,addDate,isLink);
      }
      break;
  }

  if (addDate) 
  {
    var tDate = new Date();
    var pref = getDeskcutPrefs();
    var dateFormat = pref.get("date_format");
    // --- need to replace with the date in the chosen date format
    retVal = retVal + " " + formatDate(tDate, dateFormat);
    pef = null;
    
  }
  return stripBad(retVal);
}

// -----------------------------------------------------------------------------
// -- createShortcut(url,path,name)
// ---- create a desktop directory using url passed in as link url
// ------ path as the path to the directory to save in
// ------ name as the name of the file to create
function createShortcut(url,path,name) 
{
  // first up; make sure the name isn't stupid long
  // Thanks to ch819762 (May 2006 Mailing list)... Again, it's 2.5 years later.  I suck.
  name = checkLen(name);
  try 
  {
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    var filePath = path ;
    var theOS = getOS();

    switch (theOS) 
    {
        case 'win':
        {
	        filePath = filePath + "\\" + stripBad(name) + ".url";
	        break;
        }

        case 'mac':
        {
            // TODO: implement!
            break; 
        }

        case 'lin':
        {
	        filePath = filePath + "//" + stripBad(name) + ".desktop";
	        break;
        }
    }

    // ----------- CHECK FOR OVERWRITE/MAKE UNIQUE HERE --------------------
    file.initWithPath (filePath);

    if (!file.exists()) 
    {
      file.create(0x00, 0644);
    } 
    else 
    {
      filePath = checkOverwrite(filePath);
      file.initWithPath (filePath);
      file.create(0x00, 0644);
    }

    if (filePath == "") 
    {
      return false;
    } 
    else 
    {
      var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
      outputStream.init(file, 0x20 | 0x02, 00004,null);
      // Fix from August 2007 mailing list.  OK, it's Dec 2008.  I'm a slacker...
      var converterOutputStream = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
      converterOutputStream.init(outputStream, "UTF-8", 0, 0x0000);
     
      
      var output = "";
      switch (theOS) 
      {
        case 'win':
        { 
            output = "[DEFAULT]\nBASEURL=" + url + "\n[InternetShortcut]\nURL=" + url + "\n"; 
            break;
        }
        case 'mac':
        {
            // TODO: implement!
            break;
        }
        case 'lin':
        {
            output = "[Desktop Entry]\nEncoding=UTF-8\nIcon=text-html\nType=Link\nName=" + stripBad(name) + "\nURL=" + url + "\n"; 
            break;
        }
      }

      converterOutputStream.writeString(output);
      converterOutputStream.close();
      
      return true;
    }
  }
  catch (ex) 
  {
    alert('Bad things happened: '+ex);
    return false;
  }
}

// -----------------------------------------------------------------------------
// -- postCreate (create_status,url)
// check if any user alerts (messagebox or beeps) are to be done
function postCreate (stat,href) 
{
  var pref = getDeskcutPrefs();
  var alertAudio = pref.get("alert_audio");
  var alertBox = pref.get("alert_messagebox");
  if (alertAudio) 
  {
    var alertBeep = pref.get("alert_beep");
    var alertWav = pref.get("alert_wav");
    var gSound = Components.classes["@mozilla.org/sound;1"].createInstance(Components.interfaces.nsISound);
    if (alertBeep) 
    {
      gSound.beep();
    } 
    else if (alertWav) 
    {
      var soundURL = pref.get("wav_path");
      var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
      file.initWithPath (soundURL);
      if (file.exists()) 
      {
        var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
        var url = ioService.newURI("file:///"+soundURL, "", null);
        // REALLY need to verify the file exists before playing it...
        gSound.play(url);
        url = null;
        ioService = null;
      } 
      else 
      {
        gSound.beep();
      }
      file = null;
    }
    gSound = null;
  }

  if (alertBox) 
  {
    var outStr = getBundle("deskcut.postCreateAlert1")+" " + href;
    if (stat) 
    {
       //  Missing space in output located by Alan Ziesik (Alan.Ziesik@tesat.de)
       outStr = outStr + " " + getBundle("deskcut.postCreateAlert2");
    } 
    else 
    {
      //  Missing space in output located by Alan Ziesik (Alan.Ziesik@tesat.de)
      outStr = outStr + " " + getBundle("deskcut.postCreateAlert3");
    }
    alert (outStr);
    outStr = null;
  }
  pref = null;
}

// -----------------------------------------------------------------------------
// -- checkOverwrite(filePath)
// ---- a file exists; so check prefs for overwriting behavior.
// ---- return a path to a file that is OK to overwrite (create it if needed) or "" if not OK
// ---- deskcut.overwrite 0 == ask; 1 == Always; 2 == Never
function checkOverwrite(filePath) 
{
  var pref = getDeskcutPrefs();
  var fileOverwrite = pref.get("file_overwrite");
  var makeUnique = pref.get("make_unique");
  var dupFormat = pref.get("dup_format");
  var retVal = "";
  switch (fileOverwrite)
  {
    case 0:
      retVal = askOverwrite(filePath);
      break;

    case 1:
      if (makeUnique) 
      {
        if (dupFormat == 0) 
        {
          retVal = nextSeq(filePath);
        } 
        else 
        {
          retVal = AddStamp(filePath);
        }
      } 
      else 
      {
        retVal = filePath;
      }
      break;

    case 2:
      if (makeUnique) 
      {
        if (dupFormat == 0) 
        {
          retVal = nextSeq(filePath);
        } 
        else 
        {
          retVal = AddStamp(filePath);
        }
      } 
      else 
      {
        retVal = askOverwrite(filePath);
      }
      break;

    default:
      retVal = askOverwrite(filePath);
      break;
  }

  pref = null;
  if (retVal != "" && retVal != filePath) 
  {
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath (retVal);
    if (file.exists()) 
    {
      retVal = checkOverwrite(filePath);
    }
    file = null;
  }
  return retVal;
}

// -----------------------------------------------------------------------------
// -- askOverwrite(fPath)
function askOverwrite(fPath) 
{
  var retVal = "";
  var outStr = fPath + " " + getBundle("deskcut.askOverwrite");
  if (confirm(outStr) ) 
  {
    retVal = fPath;
  } 
  else 
  {
    retVal = "";
  }
  return retVal;
}

// -----------------------------------------------------------------------------
// --  AddStamp(fPath)
// ---- take the file path (includes .url or .desktop) and stip the extension;
// ---- add the datestamp and plop a new extension
function AddStamp(fPath) 
{
  var retVal = "";
  var theOS = getOS();
  if (theOS == 'win') 
  {
    retVal = fPath.substring(0,fPath.length-4) + " " + getDateStamp() + ".url"
  }
  else if (theOS == 'lin') 
  {
    retVal = fPath.substring(0,fPath.length-8) + " " + getDateStamp() + ".desktop"
  } 
  else if (theOS == 'mac') 
  {
    // TODO: implement!
  }
  return retVal;
}

// -----------------------------------------------------------------------------
// -- nextSeq(filePath)
// ---- take the filepath and find the next available filename in the form:
//     filename (#)
// where # is a seq number starting from 1
function nextSeq(filePath) 
{
  var retVal = "";
  var theOS = getOS();
  var laSplitPath;
  var lcName = '';
  var lcExt = '';
  var lcPath = '';
  var lnItr = 1;
  var lbFound = false;
  var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

  if (theOS == 'win') 
  {
    laSplitPath = filePath.split("\\");
    lcName = laSplitPath[laSplitPath.length - 1];
    lcPath = filePath.substring(0,filePath.length - lcName.length);
    lcName = lcName.substring(0,lcName.length - 4);
    lcExt = ".url";
  } 
  else if (theOS == 'lin') 
  {
    laSplitPath = filePath.split("/");
    lcName = laSplitPath[laSplitPath.length - 1];
    lcPath = filePath.substring(0,filePath.length - lcName.length);
    lcName = lcName.substring(0,lcName.length - 8);
    lcExt = ".desktop";
  }
  file.initWithPath (lcPath + lcName + " (" + lnItr + ")" + lcExt );
  while (file.exists() ) 
  {
    lnItr = lnItr + 1;
    file.initWithPath (lcPath + lcName + " (" + lnItr + ")" + lcExt );
  }
  retVal = lcPath + lcName + " (" + lnItr + ")" + lcExt;
  return retVal;
}
